%define _disable_ld_no_undefined 1

%define major		1
%define libname		%mklibname tw %{major}
%define libtstl		%mklibname tstl %{major}
%define libtutf		%mklibname tutf %{major}
%define libnamedevel	%mklibname %{name} -d

Summary:	A text mode Windows Manager
Name:		twin
Version:	0.9.0
Release:	%mkrel 2
License:	GPLv2
Group:		Terminals
Url:		https://github.com/cosmos72/twin
Source0:	https://github.com/cosmos72/twin/archive/v%{version}/%{name}-%{version}.tar.gz
Patch1:		0001-fix-#66_cleanup-void-usage-in-server_socket.cpp.patch
BuildRequires:	bison
BuildRequires:	gpm-devel
BuildRequires:	pkgconfig(ncurses)
BuildRequires:	pkgconfig(xft)
BuildRequires:	pkgconfig(xpm)
BuildRequires:	pkgconfig(zlib)

%description
Twin is a text-mode windowing environment:
it draws and manages text windows on a text-mode display,
like X11 does for graphical windows. It has a built-in window manager
and terminal emulator, and can be used as server for remote clients
in the same style as X11. It can display on Linux console, on X11
and inside itself.

%package -n %{libname}
Summary:	Libraries from twin
Group:		System/Libraries
Provides:	lib%{name} = %{version}-%{release}

Conflicts:	%{_lib}twin0 < 0.6.2-15

%description -n %{libname}
Twin is a text-mode windowing environment.
This package contain shared libraries to run twin.

%package -n %{libtstl}
Summary:	Libraries from twin
Group:		System/Libraries

Conflicts:	%{_lib}twin0 < 0.6.2-15

%description -n %{libtstl}
Twin is a text-mode windowing environment.
This package contain shared libraries to run twin.

%package -n %{libtutf}
Summary:	Libraries from twin
Group:		System/Libraries

Conflicts:	%{_lib}twin0 < 0.6.2-15

%description -n %{libtutf}
Twin is a text-mode windowing environment.
This package contain shared libraries to run twin.

%package -n %{libnamedevel}
Summary:	Development files from twin
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Requires:	%{libtstl} = %{version}-%{release}
Requires:	%{libtutf} = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{libnamedevel}
Twin is a text-mode windowing environment.
You need this package to build twin applications.

%prep
%autosetup -p1

%build
%global build_cflags %build_cflags -std=gnu17
%global build_cxxflags %build_cxxflags -std=gnu++17

%configure \
	--disable-static \
	--enable-wm=yes \
	--enable-wm-rc=yes \
	--enable-wm-rc-shmmap=yes \
	--enable-wm-rc-shrink=yes \
	--enable-term=yes \
	--enable-hw-tty=yes \
	--enable-hw-tty-linux=yes \
	--enable-hw-tty-twterm=yes \
	--enable-hw-tty-termcap=yes \
	--enable-hw-x11=yes \
	--enable-hw-xft=yes \
	--enable-hw-twin=yes \
	--enable-hw-display=yes

%make_build

%install
%make_install

%files
%license COPYING COPYING.LIB
%doc BUGS Changelog.txt README README.porting TODO/*
%{_bindir}/*
%{_sbindir}/*
%{_libdir}/twin/system.*
%{_libdir}/twin/*.so
%{_datadir}/%{name}/
%{_mandir}/man1/%{name}.1*

%files -n %{libname}
%license COPYING.LIB
%{_libdir}/libtw.so.%{major}{,.*}

%files -n %{libtstl}
%license COPYING.LIB
%{_libdir}/libtstl.so.%{major}{,.*}

%files -n %{libtutf}
%license COPYING.LIB
%{_libdir}/libtutf.so.%{major}{,.*}

%files -n %{libnamedevel}
%{_includedir}/Tw/
%{_includedir}/Tutf/
%{_libdir}/*.so


%changelog
* Thu May 22 2025 daviddavid <daviddavid> 0.9.0-2.mga10
+ Revision: 2185745
- fix build with gcc 15 using -std=gnu17

* Fri Oct 25 2024 daviddavid <daviddavid> 0.9.0-1.mga10
+ Revision: 2111093
- new version: 0.9.0
- now libmajor is 1
- split out all libs in their own sub-pkg

* Wed Mar 30 2022 umeabot <umeabot> 0.6.2-14.mga9
+ Revision: 1835344
- Mageia 9 Mass Rebuild

* Thu Aug 20 2020 joequant <joequant> 0.6.2-13.mga8
+ Revision: 1616811
- fix gcc10 build
+ danf <danf>
- Switch URLs from http: to https:

* Fri Feb 14 2020 umeabot <umeabot> 0.6.2-12.mga8
+ Revision: 1517519
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sun Sep 23 2018 umeabot <umeabot> 0.6.2-11.mga7
+ Revision: 1301479
- Mageia 7 Mass Rebuild

* Wed Feb 17 2016 umeabot <umeabot> 0.6.2-10.mga6
+ Revision: 963121
- Mageia 6 Mass Rebuild

* Thu Oct 22 2015 daviddavid <daviddavid> 0.6.2-9.mga6
+ Revision: 894152
- do not strip binaries to fix empty debuginfo (turn on debugging mode)

* Wed Oct 15 2014 umeabot <umeabot> 0.6.2-8.mga5
+ Revision: 748450
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0.6.2-7.mga5
+ Revision: 689996
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 0.6.2-6.mga4
+ Revision: 532616
- Mageia 4 Mass Rebuild

* Wed Aug 21 2013 wally <wally> 0.6.2-5.mga4
+ Revision: 468862
- drop major from devel pkg name

* Mon Jan 14 2013 umeabot <umeabot> 0.6.2-4.mga3
+ Revision: 384923
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Sep 29 2011 fwang <fwang> 0.6.2-3.mga2
+ Revision: 150246
- tighten br

* Tue Apr 19 2011 ennael <ennael> 0.6.2-2.mga1
+ Revision: 88303
- fix build require
- clean spec file
- imported package twin


* Wed Dec 08 2010 Oden Eriksson <oeriksson@mandriva.com> 0.6.2-2mdv2011.0
+ Revision: 615280
- the mass rebuild of 2010.1 packages

* Mon Feb 15 2010 Shlomi Fish <shlomif@mandriva.org> 0.6.2-1mdv2010.1
+ Revision: 506241
- Upgrade twin to version 0.6.2

* Sun Sep 20 2009 Thierry Vignaud <tv@mandriva.org> 0.6.0-3mdv2010.0
+ Revision: 445570
- rebuild

* Fri Aug 08 2008 Thierry Vignaud <tv@mandriva.org> 0.6.0-2mdv2009.0
+ Revision: 269443
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Fri Jun 06 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 0.6.0-1mdv2009.0
+ Revision: 216301
- update to new version 0.6.0
- drop not needed patch
- spec file clean

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - BR gtk-devel & xpm-devel
    - kill re-definition of %%buildroot on Pixel's request
    - use %%mkrel

  + Olivier Thauvin <nanardon@mandriva.org>
    - Import twin



* Mon Nov 01 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 0.4.6-5mdk
- fix build with new autotools
- add BuildRequires: X11-devel libgtk+-devel libgpm-devel libggi-devel

* Sat Aug 30 2003 Marcel Pol <mpol@gmx.net> 0.4.6-4mdk
- buildrequires bison

* Sun May 25 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 0.4.6-3mdk
- distlint again

* Thu May 01 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 0.4.6-2mdk
- distlint fix

* Mon Mar 31 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 0.4.6-1mdk
- 2.4.6

* Wed Feb 26 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 0.4.5-2mdk
- fix configure

* Tue Feb 25 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 0.4.5-1mdk
- First mdk package
